﻿Option Strict On
Option Explicit On
Imports System.IO
Imports System.Text
Imports System.Security.Cryptography
Public Class Form1
    Private Sub btLoad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btLoad.Click
        If Open.ShowDialog = Windows.Forms.DialogResult.OK Then ListViewLoad(ListView1, Open.FileName)
    End Sub
    Private Sub btSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btSave.Click
        If Save.ShowDialog = Windows.Forms.DialogResult.OK Then ListViewSave(ListView1, Save.FileName)
    End Sub
    Private Sub btAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btAdd.Click
        Dim s As String = InputBox("Adding value")
        If s <> "" Then ListView1.Items.Add(s)
    End Sub
    Private Sub btDel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btDel.Click
        For Each item As ListViewItem In ListView1.SelectedItems
            ListView1.Items.Remove(item)
        Next
    End Sub
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        With Open
            .Filter = "All Files|*.*"
            .Multiselect = False
        End With
        Save.Filter = "All Files|*.*"
    End Sub
    Public Function ListViewLoad(ByRef lv As ListView, ByVal sPath As String) As Boolean
        Dim sLine As String, sItem() As String
        Dim itemX As ListViewItem, iCols As Integer
        iCols = lv.Columns.Count
        Dim sFileTxt As String = System.IO.File.ReadAllText(sPath)

        'Die nächsten 2 Zeile müsses Secret sein (da musst du selber schauen)
        Dim yourIv() As Byte = {8, 7, 6, 5, 4, 3, 2, 1}
        Dim yourPW() As Byte = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24}
        Dim ct As New cryptTripleDES(yourPW, yourIv)
        Dim sTxt() As String = ct.Decrypt(sFileTxt).Split(vbNewLine.ToCharArray)
        With lv.Items
            For Each s As String In sTxt
                If Not s.Trim = String.Empty Then
                    sLine = s
                    sItem = Split(sLine, "##")
                    itemX = .Add(sItem(0).Trim, sItem(1).Trim)
                    For I = 2 To iCols
                        itemX.SubItems.Add(sItem(I))
                    Next I
                End If
            Next
        End With
    End Function
    Public Function ListViewSave(ByRef LstVw As ListView, ByVal Path As String) As Boolean
        ListViewSave = False
        If ((LstVw IsNot Nothing) AndAlso (Not Path = String.Empty)) Then
            Dim lvCont As String = String.Empty
            For i As Integer = 0 To LstVw.Items.Count - 1
                lvCont &= LstVw.Items.Item(i).Text & "##"
                For Int As Integer = 0 To LstVw.Items.Item(i).SubItems().Count - 1
                    lvCont &= LstVw.Items.Item(i).SubItems(Int).Text & "##"
                Next
                lvCont &= vbNewLine
            Next
            If System.IO.File.Exists(Path) Then
                System.IO.File.Delete(Path)
            End If

            'Die nächsten 2 Zeile müsses Secret sein (da musst du selber schauen)
            Dim yourIv() As Byte = {8, 7, 6, 5, 4, 3, 2, 1}
            Dim yourPW() As Byte = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24}
            Dim ct As New cryptTripleDES(yourPW, yourIv)
            System.IO.File.AppendAllText(Path, ct.Encrypt(lvCont))
            Return True
        End If
    End Function
End Class
Public Class cryptTripleDES
    Private iv() As Byte
    Private key() As Byte
    Private utf8 As New UTF8Encoding
    Private des As New TripleDESCryptoServiceProvider
    Public Sub New(ByVal key() As Byte, ByVal iv() As Byte)
        Me.key = key : Me.iv = iv
    End Sub
    Public Function Encrypt(ByVal input() As Byte) As Byte()
        Return Transform(input, des.CreateEncryptor(key, iv))
    End Function
    Public Function Decrypt(ByVal input() As Byte) As Byte()
        Return Transform(input, des.CreateDecryptor(key, iv))
    End Function
    Public Function Encrypt(ByVal txt As String) As String
        Dim input() As Byte = utf8.GetBytes(txt)
        Dim output() As Byte = Transform(input, des.CreateEncryptor(key, iv))
        Return Convert.ToBase64String(output)
    End Function
    Public Function Decrypt(ByVal txt As String) As String
        Dim input() As Byte = Convert.FromBase64String(txt)
        Dim output() As Byte = Transform(input, des.CreateDecryptor(key, iv))
        Return utf8.GetString(output)
    End Function
    Private Function Transform(ByVal input() As Byte, ByVal CryptoTransform As ICryptoTransform) As Byte()
        Dim res() As Byte = Nothing
        Using ms As New MemoryStream
            Using cs As New CryptoStream(ms, CryptoTransform, CryptoStreamMode.Write)
                cs.Write(input, 0, input.Length)
                cs.FlushFinalBlock()
                ms.Position = 0
                res = New Byte(CInt(ms.Length - 1)) {}
                ms.Read(res, 0, CType(res.Length, System.Int32))
                ms.Close() : cs.Close()
                Return res
            End Using
        End Using
    End Function
End Class